/************************************************************************
 This Gauss program controls forecasting with ACH model 
************************************************************************/

output file = junk reset;
format 16,8;
dseed = 9137841;   @ resets random number generator so that identical sample is used 
                                    each time @
#include ..\..\newdata\achweek\readdatb;  @ reads in data  @
load lastmonth[capt,4] = ..\..\newdata\achweek\lagtar.out;
	@ Output file created by lagtar.g.  First row = 3/1/84, last row = 4/26/01.  Weekly data.  
	col 1 = Friday following the Thurs-Wed week corresponding to row t
	col 2 = fed funds target during week t
	col 3 = Friday following the Thurs-Wed week that was the last week during the
                    previous month prior to row t
	col 4 = fed funds target during week indicated in col. 3 @
lastmonth = lastmonth[.,4];

load monthdum[919,1] = ..\..\newdata\achweek\monthdat.csv;
load monthcou[919,2] = ..\..\newdata\achweek\monthcou.txt;
load weekfores[capt,60] = ..\foreout\basefore\Tarfores.out;  @ loads base-case forecasts
	from weekly model @
tbreak = 301;
inittarget = 9.5;     @ value assumed for pre-sample value of target @

/*******************************************************************************************

			ESTIMATE VAR FOR AUXILIARY VARIABLES

********************************************************************************************/

xs = spread6;  
plag = 1;   @ order of auxiliary VAR; note code is not written for general case of plag > 1
			in many spots @
nfirst = plag+1;           @ first observation used to estimate VAR @
nlast =  capt;                   @ last observation used to estimate VAR @
b0 = 0; ny = 0; phi = 0;         @ needed to load proc; not used in this code @
#include ..\monthly\varproc2.g;
xvar = multlags(target[1:nlast,1] ~ xs[1:nlast,.],plag,nfirst);
xvar = target[nfirst:nlast,1] ~ xvar; 
	 @adds contemporaneous target as first explanatory variable @
{bhat,vhat,ehat} = varit(xs[nfirst:nlast,.],xvar);    @ estimates regression
			if ns = cols(xs is number of explanatory variables (not counting target),
			then bhat is (ns x 2+plag*(ns+1)) matrix, whose ith row is coefficients
			to predict ith variable, first column is coefficient on current target,
			second column is coefficient on constant term, cols 3 through 3+plag-1
			are coefficients on lags 1 through plag of target, cols 3+plag through 
			3+2*plag-1 are coefficients on lags 1 through plag of first element of xs @
"var coefficients";bhat;
vroot = chol(vhat);

   @ vroot = 0;  @
	@ this line is for code checking-- delete before using! @ 

/******************************************************************************************

			SET UP MODEL WITH PROBIT PARAMETERS 

********************************************************************************************/

@	create probit explanatory variables  @
event[1,1] =0;

@	set values for parameters to maximum likelihood estimates  @
let thprob[6,1] = 
       2.5449149       0.54142729       -1.8948826      -0.42001991 
   -0.0052515480        1.5173916 ;
delprob = thprob[1:2,1];
cvec = thprob[3:6,1];
sj = -0.5 | -0.25 | 0 | 0.25 | 0.5;

/*******************************************************************************************
	
			SET UP ACH MODEL WITH PARAMETERS 

*******************************************************************************************/

zach = ones(capt,1) ~ lagfomc ~ fomc ~ abs(spread6);
	@ note this is matrix that contains all the variables used in either subsample @

del1 = 1.2574394    |   -2.0438131 | 0 | 0;
del2 =        29.390652   | 0 |   -23.045727   |    -8.2087573 ;
thet1 = 0.089877909  ;  
bet1 =     0.84665258;
thet2 = 0.067460919 ;
bet2 = 0;
meandur1 = meanc(duration[1:300,1]);

	@ these numerical values used for code checking @
	@ meandur1 = 2;
	del1 = 1 | -2 | 0 | 0 ;
	thet1 = .1;
	bet1 = .9;  @

/****************************************************************************
	set control parameters 
 ****************************************************************************/
kbreak = 1;    @ kbreak = 0 means no break, kbreak = 1 means break @
kshort = 0;    @ use kshort = 0 and kbreak = 1 for full data set,
			 kshort = 1 and kbreak = 0 for short debugging @
if kshort == 0;
	t1 = capt;
	meandur2 = meanc(duration[301:t1,1]);   
else;
	t1 = 30;
	meandur2 = 0;   @ to keep code from tripping when loading proc @
endif;

dellit = 	0.1;              @ dellit is smoothness parameter for transition between m(z) = 0 and
                                    m(z) = z @
delsmall = 0.0001;      @ delsmall is the value of el(0) in equation (13) @
icont = 0; kcont = 0;itrip = zeros(t1,1);itrip2 = itrip;
				    @ global parameters to set target to prespecified values, if desired;
					icont = 0 uses no preset value @
tf0 = 1;   @ first date for forecast analysis @
tf1 = t1;   @ last date for forecast analysis @
/*  this was for old code

numrest = 0;       @ numrest = number of restrictions on forecasts, use numrest = 0 for
				no restrictions @
restr = 0;             @ (numrest x 1) vector to restrict last values of forecast, = 0 if no
				restrictions @ */


iinit = 9.5;	    @ value assumed for pre-sample target @
chinit = 0;			@ value assumed for pre-sample change in target @
/*********************************************************************************
	set up appropriate forecast variables for each date 
 *********************************************************************************/
icontrol = 4;
if icontrol == 1;
	"forecasts based on actual historical values";
elseif icontrol == 2;
	"forecasts restricted so that i(t) = i(m(t)) for m(t) the date of the last week";
	"of the previous month";
elseif icontrol == 3;
	"forecasts restricted so that i(t) = i(m(t)) + 0.25";
elseif icontrol == 4;
	"forecasts restricted so that i(t) = predicted value";
endif;

hor = 60;
#include forepro7.g;
procstart = 1;
"first row of foreall is forecast for date";;fridate[procstart,1];
"last row of foreall is forecast for date";;fridate[t1,1];
"note first row of foreall should be discarded";

foreall = zeros(t1+hor,hor);

it = 2;
do until it > t1;
	ihist = target[1:it,1];
	if icontrol > 1;
		monthstart = monthcou[it,1];
		monthend = monthcou[it,2];
		if icontrol == 2;
			ihist[it-monthstart:it,1] = target[it-monthstart,1]*ones(monthstart+1,1);
		elseif icontrol == 3;
			ihist[it-monthstart:it,1] = (target[it-monthstart,1]+0.25)*ones(monthstart+1,1);
		elseif icontrol == 4;
			izzy = 0;
			do until izzy == monthstart;
				ihist[it-izzy,1] = weekfores[it-izzy,monthstart-izzy];
			izzy = izzy+1;
			endo;
		endif;
	endif;

	@ "";
	fridate[it,1];
	ihist'; @

	nmonte =  100;  @100 @       @ nmonte is the number of simulations per observation @
	imonte = 1;
	do until imonte > nmonte;
		{fores,sims} = multiperiod(ihist,hor,procstart);
		@ "-----------";fridate[it,1];
		fores;
		sims;
		"";"";""; @
		iz = 1;
		do until iz > hor;
			foreall[(it + iz -1), iz] = foreall[(it + iz -1), iz] + fores[1,iz];
		iz = iz + 1;
		endo;
	imonte = imonte + 1;
	endo;
it = it  + 1;
endo;

foreall = foreall / nmonte;
 @ foreall = fridate[1:t1,1] ~ foreall[1:t1,.]; @
output off;
output file = tarfores.out reset;
	foreall[1:t1,.];
output off;
output file = junk on;
	

"variance for target changes";;
qz = target[2:t1,1] - target[1:t1-1,1];
meanc(  (qz - meanc(qz))^2  );

"mean squared errors for target";
junny = target[1:t1,1] - foreall[1:t1,.];
junny = junny[hor+1:t1,.];
junny = meanc(junny^2);
junny';
"standard errors";
sqrt(junny');

