@ This GAUSS code controls VAR analysis @
	output file=junk reset;

format /m3;

/* ==================================================
	load data
  ==================================================== */
nt = 403;
load y[nt,7] = ..\..\newdata\varmonth\jdhjor.txt;
@ first row 1964:2  last row 1997:8 
 	col (1)  date
	col (2)  employment
	col (3)  price
	col (4)  pcom
	col (5)  fed funds rate
	col (6) nbrx
	col (7) dm2  @

yq = y[.,2:7];    @ drops the date @

/* =======================================================
	set global variables used in procs
    ======================================================= */
nfest = 13;   @ nfest is the first observation used for estimation (after lags) @
nuse = nt - nfest +1;   @ nuse is the number of observations used @
plag = 12;       @ plag is number of lags in VAR @
vhat = 0;         @ this will be set to the structural variance-covariance matrix for VAR @
ks = 12;            @ ks is number of horizons used for forecasts or impulse-response @
ny = 6;            @ ny is number of left-hand variables in VAR @
kc = 2;             @ kc = 2 prints output of VAR analysis, kc = 1 suppresses output @
phi = 0;             @ phi will contain lagged VAR coefficients; set to 0 to load procs @
b0 = eye(ny);    @ indicates ordinary nonstructural VAR will be used @

#include varproc2.g;   @ this adds GAUSS VAR procs @

@	construct data matrix with lags of each variable, 1965:2 to 1997:8  @
xq = multlags(yq,plag,nfest);

@	estimate VAR  @
{bhat,vhat,ehat} = varit(yq[nfest:nt,.],xq);
/* I don't think I need these two lines
k0 = bhat[.,1];  @ k0 is column of constant terms @
phi = bhat[.,2:cols(bhat)];  @ phi is matrix of VAR coefficients @ */

"standard errors";sqrt(diag(vhat))';

/* ========================================================
    calculate forecasts
    ======================================================== */
t0 = 1;    @ t0 is the first observation for evaluation
				use t0=1 for complete sample
				use t0 = 230 to start with 1984:3 @
"first observation:";;y[nfest+t0-1,1];
t1 = nuse;  @ t1 is the last observation for evaluation
				 use t1=nuse for complete sample 
				 use t1 = 389 to end with 1997:6 @

"last observation:";;y[nfest+t1-1,1];
ks = 12;
@ ks is number of forecasts evaluated @
yq = yq | zeros(ks,ny);    @ adds zeros so that code can calculate full vector;
	code should always ignore these phony yq's by construction @

ih = 1;
xfore = xq;     @ xfore will contain the matrix of variables appropriate for forming
                           the ih-period-ahead forecasts; initially set to go for ih = 1; 
			 is nuse x (1 + ny*plag) @

do until ih > ks;
	fore = xfore*bhat';  @ fore will contain the ih-period-ahead forecasts;
			           is nuse x ny @

	@ summarize forecasts @
	"";ih;;"period-ahead forecasts";
	mse = yq[nfest+ih-1:nt+ih-1,.] - fore;
	mse = mse[t0:minc(t1|nuse-ih+1),.];
	mse = mse'*mse/(rows(mse));
	"forecast mean square errors";
	(diag(mse))'; 
	"standard errors";
	sqrt(diag(mse))';
	iz = 1;
	do until iz > nuse;
		xfore[iz,.] = 1 ~ readj( fore[iz,.]',xfore[iz,2:cols(xfore)],ny);
	iz = iz+1;
	endo;
ih = ih +1;
endo;