@  This GAUSS program creates a weekly series whose value for week t is the value the
	Fed funds target assumed during the last week of the last complete month prior
	to week t @


/**************************************************************************
	 read in weekly data   
  ************************************************************************/
output file=junk reset;
#include d:\jdhdat\jorda\_May2001\jdh\newdata\achweek\readdatb; 
load monthdum[919,1] = ..\..\newdata\achweek\monthdat.csv;
t1 =896;         @ t1 is the last period analyzed in weekly analysis @

proc lastmonth(x);
@ this proc creates a weekly series whose output value for any week is 
	the value that the input vector assumed for the last week during the
	last complete month prior to week t; first 5 values are -1000 by construction @
local y, it,ij;
y = -1000*ones(t1,1);         @ this can be used to make sure no entry fails to get filled @
it = 6;
do until it > t1;
	ij = 0;
	do until ij > 5;
		if monthdum[it-ij,1] == 1;
			y[it,1] = x[it-ij-1,1];
			ij = 5;
		endif;
	ij = ij+1;
	endo;
it = it+1;
endo;
retp(y);
endp;

datex = lastmonth(fridate);
datex[1:5,1] = 19840224* ones(5,1);

outtar = lastmonth(target);
outtar[1:5,1] = 9.5*ones(5,1);

mz = fridate ~ target ~ datex ~ outtar;

"date  target lagdate lagtarget";
mz;



	