@  This GAUSS program reads in weekly forecasts from ACH model
	and translates them into monthly, compares with actual data @

format /mb1;
/**************************************************************************
	 load in data for ACH  
  ************************************************************************/
output file=junk reset;
#include d:\jdhdat\jorda\_May2001\jdh\newdata\achweek\readdatb; 
load monthdum[919,1] = ..\..\newdata\achweek\monthdat.csv;
hor = 60;    @ hor is number of weekly horizons analyzed @
t1 =896;         @ t1 is the last period analyzed in weekly analysis @

load tarbase[t1,hor] = ..\foreout\basefore\tarfores.out;

load tarit1[t1,hor] = ..\foreout\it1\tarfores.out;
@ load tarit[t1,hor] = ..\achfore\tarfores; @
load tarit1and25[t1,hor] = ..\foreout\it1and25\tarfores.out;
load lagtargetweeks[t1,4] = ..\..\newdata\achweek\lagtar.out; 
lagtargetweeks = lagtargetweeks[.,4]; 
load tarihat[t1,hor] = ..\foreout\ihat\tarfores.out;


#include monthch.g;

/****************************************************************************
	convert ACH weekly forecasts to a monthly basis 
  ***************************************************************************/
hormonths = 12;       @ hormonths is the max forecast horizon in months @

@ first eliminate all rows except those corresponding to end of month @

indexofweeks = seqa(1,1,t1);
indexofweeks = weektomonth(indexofweeks,1); 
		 @ this gives week 	corresponding to each month @

tarbase = weektomonth(tarbase,1);

 tarit1 = weektomonth(tarit1,1);
tarit1and25 = weektomonth(tarit1and25,1); 
tarihat = weektomonth(tarihat,1);

targetmonths = weektomonth(target,1);
fridatemonths = weektomonth(fridate,1);
lagtargetmonths = weektomonth(lagtargetweeks,1);

tnum = rows(tarbase);     @ size of monthly data base @

"first month is that characterized by the week beginning the day before Friday";;
fridate[indexofweeks[1,1],1];;
"which should be same as";;fridatemonths[1,1];
"last month is characterized by the week beginning the day before Friday";;
fridate[indexofweeks[tnum,1],1];;
"which should be same as";;fridatemonths[tnum,1];

@ now convert columns of weekly forecasts to monthly columns @

tarbasemonths = zeros(tnum,hormonths);

tarit1months = zeros(tnum,hormonths);
tarit1and25months = zeros(tnum,hormonths); 
tarihatmonths = zeros(tnum,hormonths);

it = 2;
do until it > tnum;
	hormax = minc(indexofweeks[it,1] | hor);  @ number of weeks we want to convert @
	hormonthmax = minc(it | hormonths);    @ number of months of forecasts we could have@
	tarbasemonths[it,1:hormonthmax] = 
		convertforecasts(tarbase[it,1:hormax],indexofweeks[it,1],hormonthmax);
	tarit1months[it,1:hormonthmax] = 
		convertforecasts(tarit1[it,1:hormax],indexofweeks[it,1],hormonthmax);
	tarit1and25months[it,1:hormonthmax] = 
		convertforecasts(tarit1and25[it,1:hormax],indexofweeks[it,1],hormonthmax); 
	tarihatmonths[it,1:hormonthmax] =
		convertforecasts(tarihat[it,1:hormax],indexofweeks[it,1],hormonthmax); 

it = it +1;
endo;

@ "fridatemonths lagtarmonths tarit1months tarit1and25 months tarihatmonths";
junny = fridatemonths ~ lagtargetmonths[.,1] ~ tarit1months[.,1] ~ tarit1and25months[.,1] ~
	tarihatmonths[.,1];
junny[1:20,.];
end; @
 
/**************************************************************************************
	load in data from monthly data base
  **************************************************************************************/

/*  use this code to replicate analysis with original data set 
nt = 403;
load yz[nt,7] = ..\..\newdata\varmonth\jdhjor.txt;
@ first row 1964:2  last row 1997:8 
 	col (1)  date
	col (2)  employment
	col (3)  price
	col (4)  pcom
	col (5)  fed funds rate
	col (6) nbrx
	col (7) dm2 
	note that in the original data set, March, 1984 corresponds to observation # 243 of yz
	 @ */

/* use this code for updated data */
nt = 505;
load yz[nt,7] = ..\..\newdata\varmonth\mvardat.csv;
@ first row 1959:2 last row 2001:2
	col (1)  date
	col (2)  employment
	col (3)  price
	col (4)  pcom
	col (5)  fed funds rate
	col (6) nbrx
	col (7) dm2 

	Note that in new data set March, 1984 corresponds to observation # 302 of yz.
	Hence the first row of tarbasemonths (which was a row of zero or null forecasts,
	since there was no 1-month-ahead forecast formed for 3/29/84) corresponds to
	row h0 = 302 of yz.

	If there are hormonths horizons, the first complete non-null row of tarbasemonths
	is row hormonths+1, so, on original data set, this is indexed by h0 + hormonths +1 @
	
h0 = 302;
hnum = h0 + hormonths;

tarbasemonths = zeros(h0-1,hormonths) | tarbasemonths;
tarit1months = zeros(h0-1,hormonths) | tarit1months;
tarit1and25months = zeros(h0-1,hormonths) | tarit1and25months;
tarihatmonths = zeros(h0-1,hormonths) | tarihatmonths;
lagtargetmonths = zeros(h0-1,1) | lagtargetmonths; 

targetmonths = zeros(h0-1,1) | targetmonths; 
fridatemonths = zeros(h0-1,1) | fridatemonths;
indexofweeks = zeros(h0-1,1) | indexofweeks;

ht0 = h0+hormonths+1;
ht1 = rows(tarbasemonths);
"check on date alignment: the week beginning the day before"; 
fridate[indexofweeks[ht0,1],1];;
"should equal";;fridatemonths[ht0,1];;
"and should be the last week of month";;yz[ht0,1];

"this month corresponds to the first set of usable complete monthly forecasts";
"it is row 1 of the vector created on *.mon output files and is row";;ht0;;
"on the original data matrix yz";

if h0 + tnum <= rows(yz);
	errs = yz[1:h0+tnum,5] - tarbasemonths;
	errs = errs[ht0:h0+hormonths+tnum,.];
else;
	"last usable forecast is that for month";yz[rows(yz),1];
	errs = yz[.,5] - tarbasemonths[1:rows(yz),.];
	errs = errs[ht0:rows(yz),.];

endif;

junny = yz[ht0:rows(yz),1] ~ yz[ht0:rows(yz),5] ~ tarbasemonths[ht0:rows(yz),1];
"date   actual   forecast";
junny;
"";
"mean squared errors";
meanc(errs^2)';
"standard deviations";
junny = sqrt(meanc(errs^2))'; junny;

output off;
output file=base.mon reset;
junny = fridatemonths[ht0:ht1,1] ~tarbasemonths[ht0:ht1,.];
junny;
output off;

output file=it1.mon reset;
junny = fridatemonths[ht0:ht1,1] ~tarit1months[ht0:ht1,.];
junny;
output off;

output file = it1and25.mon reset;
junny = fridatemonths[ht0:ht1,1] ~tarit1and25months[ht0:ht1,.];
junny;
output off;

output file = ihat.mon reset;
junny = fridatemonths[ht0:ht1,1] ~ tarihatmonths[ht0:ht1,.];
junny;
output off;

output file = lagtar.mon reset;
junny = fridatemonths[ht0:ht1,1] ~lagtargetmonths[ht0:ht1,.];
junny;
output off; 


