proc weektomonth(xweek,procfirst);
@ this proc takes a (tproc x kproc) matrix of weekly observations
	for which observation #1 corresponds to calendar date procfirst
	(where procfirst =1 signifies 3/1/84, procfirst = 2 signifies 3/8/84, and so on)
	and converts to a matrix of monthly observations where observation for month tau
	is the last week of the month 

	if procfirst = 1, first observation is week beginning 3/29/84
	global monthdum = (919 x 1) vector whose row t = 1 if week t is the
	 first week of a month @
local it, xmonth,tproc,kproc, ijunk;
tproc = rows(xweek);
kproc = cols(xweek);
xmonth = zeros(1,kproc);    @ dummy observation to be removed when all is finished @
it = 2;
do until it > tproc;
	ijunk = it + procfirst -1;
	if monthdum[ijunk,1] > 0;  
		xmonth = xmonth | xweek[it-1,.];
	endif;
it = it+1;
endo;
xmonth = xmonth[2:rows(xmonth),.];
retp(xmonth);
endp;

proc convertforecasts(xfore,datex,hormonths);
	@ inputs:
		xfore = (1 x horweeks) vector
			first element = 1-week-ahead forecast of variable for week datex (formed
				at week datex - 1)
			second element = 2-week-ahead forecast of variable for week datex (formed
				at week datex - 2)
		hormonths = number of months of forecast desired
	   output:
		yfore = (1 x hormonths) vector
			first element = 1-month ahead forecast of variable for last week of month
				(formed at last week of previous month)
			second element = 2-month ahead forecast   @
local yfore,horweeks;
	horweeks = cols(xfore);
	xfore = rev(xfore');
		@ this converts xfore to a (horweeks x 1) vector whose first element is a forecast
			formed at week datex - horweeks, second element is a forecast formed
			at week datex - horweeks + 1 @
	yfore = weektomonth(xfore,datex-horweeks);
			@ yfore is column vector whose first element is the first forecast in xfore
				that was formed at the end of a month, second element is second
				such forecast, and so on @
	yfore = rev(yfore);
			@ now first element of yfore is a 1-month-ahead forecast, second element
				is a two-month-ahead forecast, and so on @
	if rows(yfore) < hormonths;
		horweeks;;"is not enough weekly forecasts to generate a true";;hormonths;;
			"months ahead forecast";
		end;
	endif;
yfore = yfore[1:hormonths,1]';
retp(yfore);
endp;
			


 

